# Poco::Net

# class ICMPPacketImpl

Library: Net
Package: ICMP
Header: Poco/Net/ICMPPacketImpl.h

## Description

This is the abstract class for ICMP packet implementations.

## Inheritance

Known Derived Classes: ICMPv4PacketImpl

## Member Summary

Member Functions: checksum, errorDescription, getDataSize, initPacket, maxPacketSize, nextSequence, packet, packetSize, resetSequence, sequence, setDataSize, time, typeDescription, validReplyID

## Constructors

### ICMPPacketImpl

ICMPPacketImpl(
int dataSize = 48
);

Constructor. Creates an ICMPPacketImpl.

## Destructor

### ~ICMPPacketImpl

virtual ~ICMPPacketImpl();

Destructor.

## Member Functions

### errorDescription

virtual std::string errorDescription(
Poco::UInt8 * buffer,
int length
) = 0;

Returns error description string. If supplied buffer contains an ICMP echo reply packet, an empty string is returned indicating the absence of error.

Supplied buffer includes IP header, ICMP header and data. Must be overriden.

### getDataSize

int getDataSize() const;

Returns data size.

### maxPacketSize

virtual int maxPacketSize() const;

Returns the maximum permitted size of packet in number of octets.

### packet

const Poco::UInt8 * packet(
bool init = true
);

Returns raw ICMP packet. ICMP header and data are included in the packet. If init is true, initPacket() is called.

### packetSize

virtual int packetSize() const = 0;

Returns the total size of packet (ICMP header + data) in number of octets. Must be overriden.

### sequence

Poco::UInt16 sequence() const;

Returns the most recent sequence number generated.

### setDataSize

void setDataSize(
int dataSize
);

Sets data size.

### time

virtual struct timeval time(
Poco::UInt8 * buffer = 0,
int length = 0
) const = 0;

Returns current epoch time if either argument is equal to zero. Otherwise, it extracts the time value from the supplied buffer.

Supplied buffer includes IP header, ICMP header and data. Must be overriden.

### typeDescription

virtual std::string typeDescription(
int typeId
) = 0;

Returns the description of the packet type. Must be overriden.

### validReplyID

virtual bool validReplyID(
unsigned char * buffer,
int length
) const = 0;

Returns true if the extracted id is recognized (i.e. equals the process id).

Supplied buffer includes IP header, ICMP header and data. Must be overriden.

### checksum

Poco::UInt16 checksum(
Poco::UInt16 * addr,
Poco::Int32 len
);

Calculates the checksum for supplied buffer.

### initPacket

virtual void initPacket() = 0;

(Re)assembles the packet. Must be overriden.

### nextSequence

Poco::UInt16 nextSequence();

Increments sequence number and returns the new value.

### resetSequence

void resetSequence();

Resets the sequence to zero.

## Variables

### MAX_PACKET_SIZE

static const Poco::UInt16 MAX_PACKET_SIZE;

### MAX_SEQ_VALUE

static const Poco::UInt16 MAX_SEQ_VALUE;